*****************************************************************************
*                                                                           *
*  Program: COLA.PRG  ** CORRECTED VERSION OF COL.PRG Uploaded 10/24/90     *
*                     ** Apologies for the bugs in the first version!**     *
*                                                                           *
*  Written by John Weiss for the Clipper5(c) compiler                       *
*  Compuserve: 76206,333370                                                 *
*                                                                           *
*****************************************************************************
*  PROGRAM NOTES:                                                           *
*                                                                           *
*  Based on a program by:    Jones Digital, Inc.  -  David M. Jones         *
*                                     Compuserve: 73427,776                 *
*  Date...: March 1989                                                      *
*  Origional program name: SETCOLOR.PRG                                     *
*                                                                           *
*****************************************************************************
*                                                                           *
*  As a novice Clipper programmer, the first difficulty I had with the      *
*  program was compiling it, as the program name was the same as the        *
*  function name SETCOLOR(), which the UDF BOX_UP called. Oh, boy.          *
*                                                                           *
*  I decided to make the program more to my idea, so I added (in addition   *
*  to the infamous BOX_UP) the use of the PgUp and PgDn keys to scroll      *
*  the color choices in either direction. I was disturbed that the          *
*  origional program always started with a set of hard-coded colors. This   *
*  caused the user to change *every* color to keep the colors she went in   *
*  with! So I added the UDF COLORNUM(), and the code necessary to separate  *
*  the restored color string into its separate pieces. I added a box to the *
*  screen that shows the previous system colors.                            *
*                                                                           *
*  All of this took awhile(!), but my gratification when it worked made it  *
*  worth it, not to mention the stuff I learned.                            *
*                                                                           *
*  As noted below, Mr. Jones wants some money for the use of his program.   *
*  My conscience prompts me to send the man some money. I guess everyone    *
*  else is off the hook, I don't know.                                      *
*                                                                           *
*  GETTING IT TO RUN                                                        *
*                                                                           *
*  Included in this file, COLA.ZIP, is MYFUNC.LIB and #SHADZ.ZIP. Compile   *
*  COL.PRG then RLINK FI col LIB clipper, extend, myfunc. Be sure that      *
*  MYFUNC.LIB is placed in the subdirectory where clipper.lib and           *
*  extend.lib reside!                                                       *
*                                                                           *
*  The OBJ files in #SHADZ.ZIP are included in MYFUNC.LIB, but since they   *
*  are copyrighted, the library SAM.LIB is useful, and its authors want     *
*  money too, I'm passing along the whole mess. I plan to send these        *
*  fellows money as well.                                                   *
*                                                                           *
*  I would greatly appreciate any comments about this routine. Please       *
*  address them to me at the CS# above.                                     *
*                                                                           *
*****************************************************************************
*                                                                           *
*   Purpose: Give a user the ability to interactively change screen         *
*             colors and save the new colors to a COLORS.MEM file.          *
*                                                                           *
*===========================================================================*
* ORIGIONAL AUTHOR'S NOTES:                                                 *
*                                                                           *
*   1) SETCOLOR can run "stand-alone" or can easily be incorporated into    *
*   another program.                                                        *
*                                                                           *
*   2) You can use this program to learn from and/or assimilate it into     *
*   your own programming efforts.                                           *
*                                                                           *
*   3) If you use this program for personal use, please donate what you     *
*   feel it is worth ($10 suggested).  If you use it in developing          *
*   commercial software, please send $15.  If I get enough response, I      *
*   will upload some more source code programming aids for Clipper          *
*   software development.                                                   *
*                                                                           *
*   Send checks payable in U.S. dollars to:                                 *
*                                                                           *
*                Jones Digital, Inc.                                        *
*                P.O. Box 114                                               *
*                Glenn Dale, Md.  20769-0114                                *
*                                                                           *
*   Include your Compuserve ID number so I can notify you of new uploads.   *
*                                                                           *
*   Clipper is a registered trademark of Nantucket Corporation.             *
*****************************************************************************

SET CURSOR OFF
SET MESSAGE TO 24
SET WRAP ON
IF FILE("COLORS.MEM")            // If you decide to incorporate COL.PRG
   RESTORE FROM colors           // into an application, this part of the
ELSE                             // code should be removed and placed at
   c_appcol  = "W+/N,N/W"        // the beginning of the application.
   c_mescol = "W+/R"
   c_shanum = 7
   c_mshanum = 4
ENDIF
SET COLOR TO (c_appcol)
#include "inkey.ch"            // You'll probably need to relocate this as well
SAVE SCREEN TO old

******************************************************************************
* Define the color variables                                                 *
******************************************************************************

DECLARE ColorSymb[16]
ColorSymb[1]  = "N"      //  Black
ColorSymb[2]  = "B"      //  Blue
ColorSymb[3]  = "G"      //  Green
ColorSymb[4]  = "BG"     //  Cyan
ColorSymb[5]  = "R"      //  Red
ColorSymb[6]  = "BR"     //  Magenta
ColorSymb[7]  = "GR"     //  Brown
ColorSymb[8]  = "W"      //  White
ColorSymb[9]  = "N+"     //  Gray
ColorSymb[10] = "B+"     //  Bright Blue
ColorSymb[11] = "G+"     //  Bright Green
ColorSymb[12] = "BG+"    //  Bright Cyan
ColorSymb[13] = "R+"     //  Bright Red
ColorSymb[14] = "BR+"    //  Bright Magenta
ColorSymb[15] = "GR+"    //  Yellow
ColorSymb[16] = "W+"     //  Bright White

// The system colors are removed from the SETCOLOR() string to
// separate variables.

col = SETCOLOR()

StdForCol = SUBSTR(col, 1, AT("/",col) -1)
col = SUBSTR(col, AT("/",col) + 1 )
StdBacCol = SUBSTR(col,1,AT(",",col) - 1)
col = SUBSTR(col, AT(",",col) + 1)
EnhForCol = SUBSTR(col, 1, AT("/",col) -1)
col = SUBSTR(col, AT("/",col) +1)
EnhBacCol = SUBSTR(col, 1, AT(",",col) -1)
col = c_mescol
MesForCol = SUBSTR(col, 1, AT("/",col) -1)
MesBacCol = SUBSTR(col, AT("/",col) +1)

StdForNumb   =   colnum(StdForCol)
StdBakNumb   =   colnum(StdBacCol)
EnhForNumb   =   colnum(EnhForCol)
EnhBakNumb   =   colnum(EnhBacCol)
MesForNumb   =   colnum(MesForCol)
MesBakNumb   =   colnum(MesBacCol)

RELEASE StdForCol,StdBacCol,EnhForCol,EnhBacCol,MesForCol,MesBacCol,Col

SET COLOR TO(c_appcol)
CLEAR SCREEN
screen_set()                     // Paint the screen

BOX_UP(18,2,22,42,c_appcol,c_shanum)
BOX_UP(3,6,15,32,c_appcol,c_shanum)
BOX_UP(1,39,3,69,"W+/N",7," CHANGING THE DISPLAY COLORS")
SET COLOR TO c_appcol
@ 19,  3  SAY "1. Select with up and down arrow keys."
@ 20,  3  SAY "2. Press PG-UP, PG-DN to select colors."
@ 21,  3  SAY "3. Press ESC to exit."
@ 4,16 SAY " SELECT "

Showsamp()                       // Display the sample screen.

**************************************************************************
*  This is the main body of this program.                                *
*  It loops until the user presses the ESC key.                          *
**************************************************************************

DO WHILE .T.

   @  6, 9  PROMPT " Standard Foreground " MESSAGE;
         PADCH(" Press ENTER to change Prompt and Data color. ",145)

   @  7, 9  PROMPT " Standard Background " MESSAGE;
         PADCH(" Press ENTER to change Screen Background color. ",145)

   @  9, 9  PROMPT " Enhanced Foreground " MESSAGE;
         PADCH(" Press ENTER to change Highlighted Data color. ",145)

   @ 10, 9  PROMPT " Enhanced Background " MESSAGE;
         PADCH(" Press ENTER to change Highlighted Background color. ",145)

   @ 12, 9  PROMPT " Messages Foreground " MESSAGE;
         PADCH(" Press ENTER to change Program Message color. ",145)

   @ 13, 9  PROMPT " Messages Background " MESSAGE;
         PADCH(" Press ENTER to change Program Message Background color. ",145)

   MENU TO UserSelect

   DO CASE

      CASE UserSelect = 1         // Standard foreground selected.
	 StdForNumb = IncrNumb(StdForNumb)

      CASE UserSelect = 2         // Standard background selected.
         StdBakNumb = IncrNumb(StdBakNumb,"B")

      CASE UserSelect = 3         // Enhanced foreground selected.
	 EnhForNumb = IncrNumb(EnhForNumb)

      CASE UserSelect = 4         // Enhanced background selected.
         EnhBakNumb = IncrNumb(EnhBakNumb,"BB")

      CASE UserSelect = 5         // Message foreground selected.
	 MesForNumb = IncrNumb(MesForNumb)

      CASE UserSelect = 6         // Message background selected.
         MesBakNumb = IncrNumb(MesBakNumb,"BB")

      CASE UserSelect = K_RETURN  // Disarm the bugger. ENTER does nothing.
	 LOOP

      OTHERWISE                   // The ESC key was pressed -
	 EXIT                     //   exit the main program body.

   ENDCASE
   CLEAR TYPEAHEAD                // Prevents keyboard 'run-out'.
   Showsamp()                     // Update the sample screen

ENDDO

***************************************************************************
*  User has finished selecting new colors.                                *
*  Ask if new colors are to be saved to disk.                             *
***************************************************************************

SET CURSOR ON
PUBLIC c_mshanum
PRIVATE query := "N"
TONE(261.70, 2)

// MesBakNumb is one greater than its equivalent DOS number!

BOX_UP(19,47,21,67,MsgColrStr,MesBakNumb - 1," Save the changes? (Y/N)")

CLEAR TYPEAHEAD                  // Not necessary, but tidy.

// This is the simplest way I know to interact with the keyboard

query = INKEY(0)
IF  CHR(query) $ "Yy"
  c_appcol =  StdColrStr          //Screen color
  c_mescol =  MsgColrStr          //Messages color
  c_mshanum = MesBakNumb - 1      //Message shadow number
        *
*****************************************************************************

PROCEDURE  ShowSamp
PUBLIC StdColrStr, MsgColrStr
PRIVATE BoldText := "Bold Text"

// The two 'color strings' are built using the ColorSymb array.

StdColrStr = ColorSymb[StdForNumb] +"/"+;
             ColorSymb[StdBakNumb] +","+;
	     ColorSymb[EnhForNumb] +"/"+;
	     ColorSymb[EnhBakNumb]

MsgColrStr = ColorSymb[MesForNumb] +"/"+;
             ColorSymb[MesBakNumb]

// A sample box is made using the present system colors. It is static, for
// comparison with the newly selected colors.

SET COLOR TO (c_appcol)
@8,54 CLEAR TO 16,73
@  9, 57 SAY "PREVIOUS COLORS"
@  11, 57  SAY "Standard Text"
@ 13, 58  GET BoldText
SET COLOR TO (c_mescol)
@ 15, 58  SAY "Messages"
CLEAR GETS

// Next, another sample box is made of the system colors. The colors in this
// box, however, can change according to the user's whim.

SET COLOR TO (StdColrStr)
@6,37 CLEAR TO 14,56
SHADOW(6,37,14,56,c_shanum,0)
@  7, 43  SAY " RESULT "
@  9, 41  SAY "Standard Text"
@ 11, 42  GET BoldText
SET COLOR TO (MsgColrStr)
@ 13, 42  SAY "Messages"
CLEAR GETS
SET COLOR TO (c_appcol)
RETURN

******************************************************************************
*  Function Name:   Colnum                                                   *
*  Purpose:         Takes the clipper color letter code and returns the      *
*                   ColorSymb numeric code.                                  *
*  Input Argument:  The clipper color letter code.                           *
*  Output Argument: The ColorSymb numeric code.                              *
*                                                                            *
*  J.Weiss October 1990                                                      *
******************************************************************************

FUNCTION Colnum (ascc)           // Without the precision '==', the program
LOCAL ascno := 0                 // will stop at "W" if the variable ascc
DO CASE                          // contains the value "W+".
   CASE ascc ==  "N"
      ascno = 1
   CASE ascc ==  "B"
      ascno = 2
   CASE ascc ==  "G"
      ascno = 3
   CASE ascc ==  "BG"
      ascno = 4
   CASE ascc ==  "R"
      ascno = 5
   CASE ascc ==  "BR"
      ascno = 6
   CASE ascc ==  "GR"
      ascno = 7
   CASE ascc ==  "W"
      ascno = 8
   CASE ascc ==  "N+"
      ascno = 9
   CASE ascc ==  "B+"
      ascno = 10
   CASE ascc ==  "G+"
      ascno = 11
   CASE ascc ==  "BG+"
      ascno = 12
   CASE ascc ==  "R+"
      ascno = 13
   CASE ascc ==  "BR+"
      ascno = 14
   CASE ascc ==  "GR+"
      ascno = 15
   CASE ascc ==  "W+"
      ascno = 16
ENDCASE
RETURN (ascno)

*  Sets the screen to the currently chosen colors and redraws the background

PROCEDURE screen_set
SET COLOR TO(c_appcol)
FOR i = 0 TO 24
   @i,0 SAY REPLICATE(CHR(176), 80)
NEXT





